'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');

const _hoisted_1$7 = { class: "flex items-center justify-end mr-2 mt-2" };
const _hoisted_2$1 = {
  key: 0,
  class: "flex items-center cursor-pointer"
};
const _hoisted_3$1 = /*#__PURE__*/vue.createElementVNode("path", {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  d: "M18.75 19.5l-7.5-7.5 7.5-7.5m-6 15L5.25 12l7.5-7.5"
}, null, -1 /* HOISTED */);
const _hoisted_4$1 = [
  _hoisted_3$1
];
const _hoisted_5$1 = {
  key: 1,
  class: "flex items-center cursor-pointer"
};
const _hoisted_6$1 = /*#__PURE__*/vue.createElementVNode("path", {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  d: "M15.75 19.5L8.25 12l7.5-7.5"
}, null, -1 /* HOISTED */);
const _hoisted_7$1 = [
  _hoisted_6$1
];
const _hoisted_8$1 = { class: "sm:flex hidden" };
const _hoisted_9$1 = ["onClick"];
const _hoisted_10$1 = {
  key: 2,
  class: "flex items-center cursor-pointer"
};
const _hoisted_11$1 = /*#__PURE__*/vue.createElementVNode("path", {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  d: "M8.25 4.5l7.5 7.5-7.5 7.5"
}, null, -1 /* HOISTED */);
const _hoisted_12$1 = [
  _hoisted_11$1
];
const _hoisted_13$1 = {
  key: 3,
  class: "flex items-center cursor-pointer"
};
const _hoisted_14$1 = /*#__PURE__*/vue.createElementVNode("path", {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  d: "M11.25 4.5l7.5 7.5-7.5 7.5m-6-15l7.5 7.5-7.5 7.5"
}, null, -1 /* HOISTED */);
const _hoisted_15$1 = [
  _hoisted_14$1
];


var script$7 = {
  __name: 'TVPagination',
  props: {
    totalRows: {
        type: Number,
        default: 0
    },
    perPage: {
        type: Number,
        default: 15
    },
    currentPage: {
        type: Number,
        default: 1
    },
},
  emits: ['update:currentPage'],
  setup(__props, { emit: __emit }) {


vue.defineComponent({
    name: 'TVPaginate'
});

const props = __props;
const emit = __emit;

const totPages = vue.ref(Math.ceil(props.totalRows/props.perPage));

const pages = vue.computed(() => {
    if (totPages.value === 1) {
        return [props.currentPage.value]
    }

    let pages = [];

    if (totPages.value > 1 && totPages.value <= 5 ) {
        for (let i = 1; i <= totPages.value; i++) {
            pages.push(i);
        }

        return pages
    }

    if (totPages.value >= 6 ) {
        let isGtThree = props.currentPage > 1;
        const baseValue = isGtThree ? props.currentPage - 1 : props.currentPage;
        for (let i = 0; i < 5; i++) {
            if (totPages.value - props.currentPage < 4) {
                pages.push(totPages.value - (4 - i));
            } else {
                pages.push(baseValue + i);
            }
        }

        return pages
    }

    return pages
});

const paginationClass = (page) => {
    let classes = [];
    if (page === props.currentPage) {
        classes.push('rounded-xl bg-gray-400 text-white');
    }

    return classes
};

const changePage = (page = null, previous = false) => {
    let increment = 0;
    if (page === null) {
        increment = previous ? -1 : 1;
        page = props.currentPage;
    }
    emit('update:currentPage', page + increment);
};

vue.watch(() => props.totalRows, (value) => {
    totPages.value = Math.ceil(value/props.perPage);
});


return (_ctx, _cache) => {
  return (vue.openBlock(), vue.createElementBlock("div", _hoisted_1$7, [
    (__props.currentPage !== 1)
      ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_2$1, [
          (vue.openBlock(), vue.createElementBlock("svg", {
            xmlns: "http://www.w3.org/2000/svg",
            fill: "none",
            viewBox: "0 0 24 24",
            "stroke-width": "1.5",
            stroke: "currentColor",
            class: "tv-paginator-size",
            onClick: _cache[0] || (_cache[0] = $event => (changePage(1)))
          }, [..._hoisted_4$1]))
        ]))
      : vue.createCommentVNode("v-if", true),
    (__props.currentPage !== 1)
      ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_5$1, [
          (vue.openBlock(), vue.createElementBlock("svg", {
            xmlns: "http://www.w3.org/2000/svg",
            fill: "none",
            viewBox: "0 0 24 24",
            "stroke-width": "1.5",
            stroke: "currentColor",
            class: "tv-paginator-size",
            onClick: _cache[1] || (_cache[1] = $event => (changePage(undefined, true)))
          }, [..._hoisted_7$1]))
        ]))
      : vue.createCommentVNode("v-if", true),
    vue.createElementVNode("div", _hoisted_8$1, [
      (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(pages.value, (page) => {
        return (vue.openBlock(), vue.createElementBlock("p", {
          key: `page_${page}`,
          class: vue.normalizeClass(["font-medium leading-none cursor-pointer link px-2", `${paginationClass(page)} tv-paginator-text`]),
          onClick: $event => (changePage(page))
        }, vue.toDisplayString(page), 11 /* TEXT, CLASS, PROPS */, _hoisted_9$1))
      }), 128 /* KEYED_FRAGMENT */))
    ]),
    (__props.currentPage !== totPages.value)
      ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_10$1, [
          (vue.openBlock(), vue.createElementBlock("svg", {
            xmlns: "http://www.w3.org/2000/svg",
            fill: "none",
            viewBox: "0 0 24 24",
            "stroke-width": "1.5",
            stroke: "currentColor",
            class: "tv-paginator-size",
            onClick: _cache[2] || (_cache[2] = $event => (changePage(undefined)))
          }, [..._hoisted_12$1]))
        ]))
      : vue.createCommentVNode("v-if", true),
    (__props.currentPage !== totPages.value)
      ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_13$1, [
          (vue.openBlock(), vue.createElementBlock("svg", {
            xmlns: "http://www.w3.org/2000/svg",
            fill: "none",
            viewBox: "0 0 24 24",
            "stroke-width": "1.5",
            stroke: "currentColor",
            class: "tv-paginator-size",
            onClick: _cache[3] || (_cache[3] = $event => (changePage(totPages.value)))
          }, [..._hoisted_15$1]))
        ]))
      : vue.createCommentVNode("v-if", true)
  ]))
}
}

};

script$7.__file = "src/components/TVPagination.vue";

const _hoisted_1$6 = {
  ref: "TVTABLE",
  class: "tv-table"
};


var script$6 = {
  __name: 'TTable',
  setup(__props) {

vue.defineComponent({
    name: 'TTable',
});


return (_ctx, _cache) => {
  return (vue.openBlock(), vue.createElementBlock("table", _hoisted_1$6, [
    vue.renderSlot(_ctx.$slots, "default")
  ], 512 /* NEED_PATCH */))
}
}

};

script$6.__file = "src/components/TTable.vue";

const _hoisted_1$5 = { class: "tv-thead" };


var script$5 = {
  __name: 'TThead',
  setup(__props) {

vue.defineComponent({
    name: 'TThead',
});


return (_ctx, _cache) => {
  return (vue.openBlock(), vue.createElementBlock("thead", _hoisted_1$5, [
    vue.renderSlot(_ctx.$slots, "default")
  ]))
}
}

};

script$5.__file = "src/components/TThead.vue";

const _hoisted_1$4 = { class: "tv-tr" };


var script$4 = {
  __name: 'TTr',
  setup(__props) {

vue.defineComponent({
    name: 'TTr',
});


return (_ctx, _cache) => {
  return (vue.openBlock(), vue.createElementBlock("tr", _hoisted_1$4, [
    vue.renderSlot(_ctx.$slots, "default")
  ]))
}
}

};

script$4.__file = "src/components/TTr.vue";

const _hoisted_1$3 = { class: "tv-th" };


var script$3 = {
  __name: 'TTh',
  setup(__props) {

vue.defineComponent({
    name: 'TTh',
});


return (_ctx, _cache) => {
  return (vue.openBlock(), vue.createElementBlock("th", _hoisted_1$3, [
    vue.renderSlot(_ctx.$slots, "default")
  ]))
}
}

};

script$3.__file = "src/components/TTh.vue";

const _hoisted_1$2 = { class: "tv-tbody" };


var script$2 = {
  __name: 'TTbody',
  setup(__props) {

vue.defineComponent({
    name: 'TTbody',
});


return (_ctx, _cache) => {
  return (vue.openBlock(), vue.createElementBlock("tbody", _hoisted_1$2, [
    vue.renderSlot(_ctx.$slots, "default")
  ]))
}
}

};

script$2.__file = "src/components/TTbody.vue";

const _hoisted_1$1 = { class: "tv-td" };


var script$1 = {
  __name: 'TTd',
  setup(__props) {

vue.defineComponent({
    name: 'TTd',
});


return (_ctx, _cache) => {
  return (vue.openBlock(), vue.createElementBlock("td", _hoisted_1$1, [
    vue.renderSlot(_ctx.$slots, "default")
  ]))
}
}

};

script$1.__file = "src/components/TTd.vue";

const _hoisted_1 = {
  key: 0,
  class: "flex items-center justify-end mr-2 mb-2 text-body"
};
const _hoisted_2 = { class: "tv-summary-size" };
const _hoisted_3 = { class: "overflow-auto" };
const _hoisted_4 = { class: "flex justify-between items-center" };
const _hoisted_5 = {
  key: 0,
  class: "ml-2"
};
const _hoisted_6 = ["stroke-width", "onClick"];
const _hoisted_7 = /*#__PURE__*/vue.createElementVNode("path", {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  d: "M4.5 15.75l7.5-7.5 7.5 7.5"
}, null, -1 /* HOISTED */);
const _hoisted_8 = [
  _hoisted_7
];
const _hoisted_9 = ["stroke-width", "onClick"];
const _hoisted_10 = /*#__PURE__*/vue.createElementVNode("path", {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  d: "M19.5 8.25l-7.5 7.5-7.5-7.5"
}, null, -1 /* HOISTED */);
const _hoisted_11 = [
  _hoisted_10
];
const _hoisted_12 = /*#__PURE__*/vue.createElementVNode("span", { class: "font-light flex justify-center mb-3 mt-3" }, "No fields set", -1 /* HOISTED */);
const _hoisted_13 = { class: "flex justify-center mb-3 mt-3" };
const _hoisted_14 = /*#__PURE__*/vue.createElementVNode("circle", {
  class: "opacity-25",
  cx: "12",
  cy: "12",
  r: "10",
  stroke: "currentColor",
  "stroke-width": "4"
}, null, -1 /* HOISTED */);
const _hoisted_15 = /*#__PURE__*/vue.createElementVNode("path", {
  class: "opacity-75",
  fill: "currentColor",
  d: "M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"
}, null, -1 /* HOISTED */);
const _hoisted_16 = [
  _hoisted_14,
  _hoisted_15
];
const _hoisted_17 = {
  key: 1,
  class: "font-light flex justify-center mb-3 mt-3"
};
const _hoisted_18 = ["checked", "value", "onClick"];
const _hoisted_19 = { class: "tv-tfoot" };


var script = {
  __name: 'TVTable',
  props: {
    items: {
        type: [Object, Array],
        default: () => []
    },
    fields: {
        type: Array,
        default: () => []
    },
    currentPage: {
        type: Number,
        default: 1
    },
    totalRows: {
        type: Number,
        default: 0
    },
    perPage: {
        type: Number,
        default: 15
    },
    spinnerClass: {
        type: String,
        default: ''
    },
    rowSelectClass: {
        type: String,
        default: ''
    },
    hidePagination: Boolean,
    hideSummary: Boolean,
    multipleSortable: Boolean,
    multipleSelection: Boolean,
    enableCheck: Boolean,
    busy: Boolean,
    noItemText: {
        type: String,
        default: 'No data to display'
    },
    summaryText: {
        type: String,
        default: 'Displaying _STR_FROM_ to _STR_TO_ of _STR_TOTAL_ items'
    },
},
  emits: [
    'update:currentPage',
    'updateSortable', 
    'changePage', 
    'checkRow', 
    'rowClicked',
],
  setup(__props, { emit: __emit }) {

vue.defineComponent({
    name: 'TVTable',
    inheritAttrs: false
});

const slots = vue.useSlots();

const props = __props;

const emit = __emit;


const localTotalRows = vue.computed(() => {
    return props.totalRows || props.items.length || 0
});

const fromRow = vue.ref(0);
const toRow = vue.ref(0);
const localCurrentPage = vue.ref(props.currentPage);

const getField = (item, field, def) => {
    return item[field] || def
};

const toggleDetails = (value) => {
    return value._showDetails = !value._showDetails
};

const sortable = vue.ref({});
const selectedRows = vue.ref([]);

const rowClicked = (item) => {
    if (props.multipleSelection) {
        
        if (selectedRows.value.includes(item)) {
            let index = selectedRows.value.indexOf(item);
            selectedRows.value.splice(index, 1);
        } else {
            selectedRows.value.push(item);
        }
    
    } else {
        selectedRows.value = selectedRows.value.includes(item) ? [] : [item];
    }

    emit('rowClicked', item);
}; 

const updateSortable = (key, sort) => {
    props.multipleSortable 
        ? sortable.value[key] = sort
        : sortable.value = {[key] : sort};

    emit('updateSortable', sortable.value);
};

const refreshCounter = () => {
    if (localCurrentPage.value === 0) {
        return
    }
    let from = (localTotalRows.value > 0) ? 1 : 0;
    if (localCurrentPage.value > 1) {
        from = from + (localCurrentPage.value - 1) * props.perPage;
    }
    let to = Math.min(from + props.perPage - 1, localTotalRows.value);
    fromRow.value = from - 1;
    toRow.value = to;
};

const checkSelectedForRow = (item) => {
    return props.multipleSelection ? selectedRows.value.includes(item) : selectedRows.value === item
};

const getSummary = vue.computed(() => {
    let text = props.summaryText.replace(/_STR_FROM_/, fromRow.value + 1);
    text = text.replace(/_STR_TO_/, toRow.value);
    text = text.replace(/_STR_TOTAL_/, localTotalRows.value);
    return text
});

vue.watch(() => localCurrentPage.value, (value) => {
    refreshCounter();
    emit('changePage', {page: value, from: fromRow.value, to: toRow.value});
    emit('update:currentPage', value);
}, {immediate: true});

vue.watch(() => localTotalRows.value, (value) => {
    refreshCounter();
});


return (_ctx, _cache) => {
  return (vue.openBlock(), vue.createElementBlock(vue.Fragment, null, [
    (!__props.hidePagination && __props.totalRows != 0 && !__props.hideSummary && !__props.busy)
      ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_1, [
          vue.createElementVNode("span", _hoisted_2, vue.toDisplayString(getSummary.value), 1 /* TEXT */)
        ]))
      : vue.createCommentVNode("v-if", true),
    vue.createElementVNode("div", _hoisted_3, [
      vue.createVNode(script$6, { ref: "TVTABLE" }, {
        default: vue.withCtx(() => [
          vue.createCommentVNode(" No fields set "),
          (__props.fields.length == 0)
            ? (vue.openBlock(), vue.createBlock(script$5, { key: 0 }, {
                default: vue.withCtx(() => [
                  vue.createVNode(script$4, { class: "divide-x divide-y" }, {
                    default: vue.withCtx(() => [
                      vue.createVNode(script$3)
                    ]),
                    _: 1 /* STABLE */
                  })
                ]),
                _: 1 /* STABLE */
              }))
            : vue.createCommentVNode("v-if", true),
          (__props.fields.length !== 0)
            ? (vue.openBlock(), vue.createBlock(script$5, { key: 1 }, {
                default: vue.withCtx(() => [
                  (vue.unref(slots)['header-row'])
                    ? vue.renderSlot(_ctx.$slots, "header-row", { key: 0 })
                    : vue.createCommentVNode("v-if", true),
                  vue.createVNode(script$4, { class: "divide-x divide-y" }, {
                    default: vue.withCtx(() => [
                      (__props.enableCheck)
                        ? (vue.openBlock(), vue.createBlock(script$3, {
                            key: 0,
                            style: {"width":"30px"}
                          }))
                        : vue.createCommentVNode("v-if", true),
                      (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(__props.fields, (field) => {
                        return (vue.openBlock(), vue.createBlock(script$3, {
                          key: field.label,
                          class: vue.normalizeClass(["font-medium uppercase", field.thClass]),
                          style: vue.normalizeStyle(field.thStyle)
                        }, {
                          default: vue.withCtx(() => [
                            vue.createElementVNode("div", _hoisted_4, [
                              vue.createElementVNode("span", null, vue.toDisplayString(field.label), 1 /* TEXT */),
                              (field.sortable)
                                ? (vue.openBlock(), vue.createElementBlock("div", _hoisted_5, [
                                    (vue.openBlock(), vue.createElementBlock("svg", {
                                      xmlns: "http://www.w3.org/2000/svg",
                                      fill: "none",
                                      viewBox: "0 0 24 24",
                                      "stroke-width": sortable.value[field.key] === 'asc' ? 4 : 2,
                                      stroke: "currentColor",
                                      class: "w-2.5 h-2.5 cursor-pointer",
                                      onClick: $event => (updateSortable(field.key, 'asc'))
                                    }, [..._hoisted_8], 8 /* PROPS */, _hoisted_6)),
                                    (vue.openBlock(), vue.createElementBlock("svg", {
                                      xmlns: "http://www.w3.org/2000/svg",
                                      fill: "none",
                                      viewBox: "0 0 24 24",
                                      "stroke-width": sortable.value[field.key] === 'desc' ? 4 : 2,
                                      stroke: "currentColor",
                                      class: "w-2.5 h-2.5 cursor-pointer",
                                      onClick: $event => (updateSortable(field.key, 'desc'))
                                    }, [..._hoisted_11], 8 /* PROPS */, _hoisted_9))
                                  ]))
                                : vue.createCommentVNode("v-if", true)
                            ])
                          ]),
                          _: 2 /* DYNAMIC */
                        }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["class", "style"]))
                      }), 128 /* KEYED_FRAGMENT */))
                    ]),
                    _: 1 /* STABLE */
                  })
                ]),
                _: 3 /* FORWARDED */
              }))
            : vue.createCommentVNode("v-if", true),
          vue.createCommentVNode(" No fields set "),
          (__props.fields.length == 0 || __props.busy)
            ? (vue.openBlock(), vue.createBlock(script$2, { key: 2 }, {
                default: vue.withCtx(() => [
                  vue.createVNode(script$4, { class: "divide-x divide-y" }, {
                    default: vue.withCtx(() => [
                      (__props.fields.length == 0)
                        ? (vue.openBlock(), vue.createBlock(script$1, { key: 0 }, {
                            default: vue.withCtx(() => [
                              _hoisted_12
                            ]),
                            _: 1 /* STABLE */
                          }))
                        : vue.createCommentVNode("v-if", true),
                      vue.createCommentVNode(" Spinner "),
                      (__props.busy)
                        ? (vue.openBlock(), vue.createBlock(script$1, {
                            key: 1,
                            colspan: __props.enableCheck ? __props.fields.length + 1 : __props.fields.length
                          }, {
                            default: vue.withCtx(() => [
                              vue.createElementVNode("div", _hoisted_13, [
                                vue.renderSlot(_ctx.$slots, "busy", {}, () => [
                                  (vue.openBlock(), vue.createElementBlock("svg", {
                                    class: vue.normalizeClass(["animate-spin -ml-1 mr-3 h-6 w-6 text-black", __props.spinnerClass]),
                                    xmlns: "http://www.w3.org/2000/svg",
                                    fill: "none",
                                    viewBox: "0 0 24 24"
                                  }, [..._hoisted_16], 2 /* CLASS */))
                                ])
                              ])
                            ]),
                            _: 3 /* FORWARDED */
                          }, 8 /* PROPS */, ["colspan"]))
                        : vue.createCommentVNode("v-if", true)
                    ]),
                    _: 3 /* FORWARDED */
                  })
                ]),
                _: 3 /* FORWARDED */
              }))
            : (vue.openBlock(), vue.createBlock(script$2, { key: 3 }, {
                default: vue.withCtx(() => [
                  vue.createCommentVNode(" No Item "),
                  (__props.items.length === 0 && !__props.busy)
                    ? (vue.openBlock(), vue.createBlock(script$4, { key: 0 }, {
                        default: vue.withCtx(() => [
                          vue.createVNode(script$1, {
                            colspan: __props.fields.length + 1
                          }, {
                            default: vue.withCtx(() => [
                              (vue.unref(slots)['no-items'])
                                ? vue.renderSlot(_ctx.$slots, "no-items", { key: 0 })
                                : (vue.openBlock(), vue.createElementBlock("span", _hoisted_17, vue.toDisplayString(__props.noItemText), 1 /* TEXT */))
                            ]),
                            _: 3 /* FORWARDED */
                          }, 8 /* PROPS */, ["colspan"])
                        ]),
                        _: 3 /* FORWARDED */
                      }))
                    : (vue.openBlock(true), vue.createElementBlock(vue.Fragment, { key: 1 }, vue.renderList(__props.items, (item, index) => {
                        return (vue.openBlock(), vue.createElementBlock(vue.Fragment, {
                          key: item.id
                        }, [
                          vue.createCommentVNode(" Table Body "),
                          vue.createVNode(script$4, {
                            id: `TVTABLE_row_${index}_${item.id}`,
                            class: vue.normalizeClass(["divide-x divide-y last:border-b-0 px-2 py-1.5 text-left border hover:bg-gray-400/50", `${index % 2 ? 'bg-gray-300/50' : 'bg-gray-100/50'}`]),
                            onClick: $event => (rowClicked(item))
                          }, {
                            default: vue.withCtx(() => [
                              (__props.enableCheck)
                                ? (vue.openBlock(), vue.createBlock(script$1, {
                                    key: `check_${item.label}`,
                                    class: vue.normalizeClass(`${checkSelectedForRow(item) ? __props.rowSelectClass || 'bg-gray-400/50' : ''}`)
                                  }, {
                                    default: vue.withCtx(() => [
                                      vue.createElementVNode("input", {
                                        id: "checkbox",
                                        checked: selectedRows.value.includes(item),
                                        value: item,
                                        type: "checkbox",
                                        onClick: vue.withModifiers($event => (rowClicked(item)), ["stop"])
                                      }, null, 8 /* PROPS */, _hoisted_18)
                                    ]),
                                    _: 2 /* DYNAMIC */
                                  }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["class"]))
                                : vue.createCommentVNode("v-if", true),
                              (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(__props.fields, (field) => {
                                return (vue.openBlock(), vue.createBlock(script$1, {
                                  key: field.key,
                                  class: vue.normalizeClass(`${field.tdClass ?? ''} ${checkSelectedForRow(item) ? __props.rowSelectClass || 'bg-gray-400/50' : ''}`),
                                  style: vue.normalizeStyle(field.tdStyle)
                                }, {
                                  default: vue.withCtx(() => [
                                    vue.renderSlot(_ctx.$slots, `cell:${field.key || field.label}`, {
                                      item: item,
                                      data: getField(item, field.key),
                                      toggleDetails: toggleDetails
                                    }, () => [
                                      vue.createTextVNode(vue.toDisplayString(getField(item, field.key, '')), 1 /* TEXT */)
                                    ])
                                  ]),
                                  _: 2 /* DYNAMIC */
                                }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["class", "style"]))
                              }), 128 /* KEYED_FRAGMENT */))
                            ]),
                            _: 2 /* DYNAMIC */
                          }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["id", "class", "onClick"]),
                          (item._showDetails)
                            ? (vue.openBlock(), vue.createBlock(script$4, {
                                key: 0,
                                class: vue.normalizeClass(index % 2 ? 'bg-gray-300/50' : 'bg-gray-100/50')
                              }, {
                                default: vue.withCtx(() => [
                                  vue.createVNode(script$1, {
                                    colspan: __props.enableCheck ? __props.fields.length + 1 : __props.fields.length
                                  }, {
                                    default: vue.withCtx(() => [
                                      vue.renderSlot(_ctx.$slots, "row-details", { item: item })
                                    ]),
                                    _: 2 /* DYNAMIC */
                                  }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["colspan"])
                                ]),
                                _: 2 /* DYNAMIC */
                              }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["class"]))
                            : vue.createCommentVNode("v-if", true)
                        ], 64 /* STABLE_FRAGMENT */))
                      }), 128 /* KEYED_FRAGMENT */))
                ]),
                _: 3 /* FORWARDED */
              })),
          vue.createElementVNode("tfoot", _hoisted_19, [
            (vue.unref(slots)['footer-row'])
              ? vue.renderSlot(_ctx.$slots, "footer-row", { key: 0 })
              : vue.createCommentVNode("v-if", true)
          ])
        ]),
        _: 3 /* FORWARDED */
      }, 512 /* NEED_PATCH */)
    ]),
    (localTotalRows.value > __props.perPage && !__props.hidePagination && !__props.busy)
      ? (vue.openBlock(), vue.createBlock(script$7, {
          key: 1,
          currentPage: localCurrentPage.value,
          "onUpdate:currentPage": _cache[0] || (_cache[0] = $event => ((localCurrentPage).value = $event)),
          "total-rows": localTotalRows.value,
          "per-page": __props.perPage
        }, null, 8 /* PROPS */, ["currentPage", "total-rows", "per-page"]))
      : vue.createCommentVNode("v-if", true)
  ], 64 /* STABLE_FRAGMENT */))
}
}

};

script.__file = "src/components/TVTable.vue";

exports.TVPagination = script$7;
exports.TVTable = script;
